import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;


public class CountingWithEntryProcessor {

	public static void main(String[] args) {

		final int ITERATIONS = 10000;
		final String COUNTER_NAME = "sequence";
		
		NamedCache namedCache = CacheFactory.getCache("counters");
				
		StopWatch stopWatch = new StopWatch();

		System.out.println("Counting (with entry processor)");
		stopWatch.start();
		for(int i = 0; i < ITERATIONS; i++) {
			
			namedCache.invoke(COUNTER_NAME, new IncrementCounterProcessor(COUNTER_NAME));
			
		}
		stopWatch.stop();
		System.out.println("Finished Counting (with entry processor)");
		
		System.out.println(stopWatch.toString(ITERATIONS));
	}

}
