import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;


public class CountingWithLocking {

	public static void main(String[] args) {

		final int ITERATIONS = 10000;
		final String COUNTER_NAME = "sequence";
		
		NamedCache namedCache = CacheFactory.getCache("counters");
		
		//create the initial counter (if and only if it doesn't exist)
		namedCache.lock(COUNTER_NAME, -1);
		if (!namedCache.containsKey(COUNTER_NAME)) {
			Counter counter = new Counter(COUNTER_NAME);
			namedCache.put(COUNTER_NAME, counter);			
		}
		namedCache.unlock(COUNTER_NAME);
				
		StopWatch stopWatch = new StopWatch();

		System.out.println("Counting (with locking)");
		stopWatch.start();
		for(int i = 0; i < ITERATIONS; i++) {
			namedCache.lock(COUNTER_NAME, -1);
			
			Counter counter = (Counter)namedCache.get(COUNTER_NAME);
			counter.increment();
			namedCache.put(COUNTER_NAME, counter);
			
			namedCache.unlock(COUNTER_NAME);
		}
		stopWatch.stop();
		System.out.println("Finished Counting (with locking)");
		
		System.out.println(stopWatch.toString(ITERATIONS));
	}

}
