import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;


public class CountingWithoutLocking {

	public static void main(String[] args) {

		final int ITERATIONS = 10000;
		final String COUNTER_NAME = "sequence";
		
		NamedCache namedCache = CacheFactory.getCache("counters");
		
		//create the initial counter
		Counter counter = new Counter(COUNTER_NAME);
		namedCache.put(COUNTER_NAME, counter);
		
		StopWatch stopWatch = new StopWatch();
		
		System.out.println("Counting (without locking)");
		stopWatch.start();
		for(int i = 0; i < ITERATIONS; i++) {
			counter = (Counter)namedCache.get(COUNTER_NAME);
			counter.increment();
			namedCache.put(COUNTER_NAME, counter);
		}
		stopWatch.stop();
		System.out.println("Finished Counting (without locking)");
		
		System.out.println(stopWatch.toString(ITERATIONS));
	}

}
