import java.io.IOException;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import com.tangosol.util.AbstractMapListener;
import com.tangosol.util.MapEvent;
import com.tangosol.util.filter.AndFilter;
import com.tangosol.util.filter.EqualsFilter;
import com.tangosol.util.filter.GreaterEqualsFilter;
import com.tangosol.util.filter.MapEventFilter;

public class EndOfDayStockSummaryAbstractMapListenerForORCLAdvanced {

	public static void main(String[] args) throws IOException {

		NamedCache namedCache = CacheFactory.getCache("eodss");

		namedCache.addMapListener(new AbstractMapListener() {
			
			public void entryInserted(MapEvent evt) {
				System.out.println(evt.getNewValue());
			}
		}, new MapEventFilter(MapEventFilter.E_INSERTED, 
							  new AndFilter(new EqualsFilter("getSymbol", "ORCL"),
									  		new GreaterEqualsFilter("getClosePrice", 40.00))), false);
			
		System.in.read();
	}

}
