import com.tangosol.util.InvocableMap.Entry;
import com.tangosol.util.processor.AbstractProcessor;


public class IncrementCounterProcessor extends AbstractProcessor {

	private static final long serialVersionUID = -7685103524534553307L;

	private String counterName;
	
	
	public IncrementCounterProcessor() {
		//for serializable
	}
	
	
	/**
	 * <p>Standard Constructor</p>
	 * 
	 * @param counterName
	 */
	public IncrementCounterProcessor(String counterName) {
		this.counterName = counterName;
	}
	
	
	/**
	 * <p>This method is executed in a storage enabled node, 
	 * for the specified {@link java.util.Map.Entry}.</p>
	 */
	public Object process(Entry entry) {

		Counter counter;
		if (!entry.isPresent()) {
			counter = new Counter(counterName);
		} else {
			counter = (Counter)entry.getValue();
		}
		
		counter.increment();
		
		entry.setValue(counter);
		
		return counter.getValue();
	}	
}
